import ruamel.yaml

DEFAULTS = {
    'path_ansible_inventory': "/etc/fuss-manager/hosts",
    'path_stats_cache': "/etc/fuss-manager/machine_stats",
    'path_playbooks': "/etc/fuss-manager/playbooks",
    'web_address': "localhost",
    'web_port': 1232,
    'arpwatch_datafile': '/var/lib/arpwatch/arp.dat',
    'dhcp_log_file': '/var/log/syslog',
    'debug': False,
    'operation_log_file': '/var/log/fuss-manager/operations.log',
    'playbook_log_dir': '/var/log/fuss-manager/playbooks.log',
    'disabled_sources': (),
    }


MOCK_VALUES = {
    'path_ansible_inventory': "./hosts",
    'path_stats_cache': "./machine_stats",
    'path_playbooks': "./tests/data/playbooks",
    'arpwatch_datafile': '/var/lib/arpwatch/arp.dat',
    'dhcp_log_file': '/var/log/syslog',
    'debug': True,
    'operation_log_file': './operations.log',
    'playbook_log_dir': './playbooks.log',
    }


class Config:
    def __init__(self, config_fname=None):
        if config_fname:
            conf = self._load_file(config_fname)
        else:
            conf = {}
        for k, v in DEFAULTS.items():
            setattr(self, k, conf.get(k, v))

    def _load_file(self, fname):
        yaml = ruamel.yaml.YAML()
        with open(fname) as fp:
            return yaml.load(fp) or {}


class MockConfig(Config):
    def __init__(self):
        super().__init__()
        for k, v in MOCK_VALUES.items():
            setattr(self, k, v)
